From e06bba8374ba486c8593138b10a256aeef42a8af Mon Sep 17 00:00:00 2001
From: Nathan Bossart <nathandbossart@gmail.com>
Date: Thu, 23 Feb 2023 10:31:24 -0800
Subject: [PATCH v4 1/1] add details to pg_input_error_message and rename to
 pg_input_error_info

---
 contrib/cube/expected/cube.out                |   8 +-
 contrib/cube/sql/cube.sql                     |   2 +-
 contrib/hstore/expected/hstore.out            |  16 +--
 contrib/hstore/sql/hstore.sql                 |   4 +-
 contrib/intarray/expected/_int.out            |  12 +-
 contrib/intarray/sql/_int.sql                 |   2 +-
 contrib/isn/expected/isn.out                  |  12 +-
 contrib/isn/sql/isn.sql                       |   2 +-
 contrib/ltree/expected/ltree.out              |  22 ++--
 contrib/ltree/sql/ltree.sql                   |   2 +-
 contrib/seg/expected/seg.out                  |  18 +--
 contrib/seg/sql/seg.sql                       |   2 +-
 doc/src/sgml/func.sgml                        |  33 +++--
 src/backend/utils/adt/misc.c                  |  42 +++++--
 src/include/catalog/pg_proc.dat               |  10 +-
 src/test/regress/expected/arrays.out          |   8 +-
 src/test/regress/expected/bit.out             |  40 +++---
 src/test/regress/expected/boolean.out         |   8 +-
 src/test/regress/expected/box.out             |  16 +--
 src/test/regress/expected/char.out            |   8 +-
 src/test/regress/expected/char_1.out          |   8 +-
 src/test/regress/expected/char_2.out          |   8 +-
 src/test/regress/expected/date.out            |  16 +--
 src/test/regress/expected/domain.out          |  34 +++---
 src/test/regress/expected/enum.out            |  16 +--
 .../expected/float4-misrounded-input.out      |   4 +-
 src/test/regress/expected/float4.out          |   8 +-
 src/test/regress/expected/float8.out          |   8 +-
 src/test/regress/expected/geometry.out        |  16 +--
 src/test/regress/expected/inet.out            |  24 ++--
 src/test/regress/expected/int2.out            |  24 ++--
 src/test/regress/expected/int4.out            |   8 +-
 src/test/regress/expected/int8.out            |   8 +-
 src/test/regress/expected/interval.out        |  16 +--
 src/test/regress/expected/json.out            |   8 +-
 src/test/regress/expected/json_encoding.out   |   8 +-
 src/test/regress/expected/json_encoding_1.out |   8 +-
 src/test/regress/expected/jsonb.out           |  16 +--
 src/test/regress/expected/jsonpath.out        |  16 +--
 src/test/regress/expected/line.out            |  40 +++---
 src/test/regress/expected/lseg.out            |   8 +-
 src/test/regress/expected/macaddr.out         |  16 +--
 src/test/regress/expected/macaddr8.out        |  16 +--
 src/test/regress/expected/money.out           |  16 +--
 src/test/regress/expected/multirangetypes.out |  16 +--
 src/test/regress/expected/numeric.out         |  24 ++--
 src/test/regress/expected/oid.out             |  32 ++---
 src/test/regress/expected/path.out            |  16 +--
 src/test/regress/expected/pg_lsn.out          |   8 +-
 src/test/regress/expected/point.out           |   8 +-
 src/test/regress/expected/polygon.out         |  16 +--
 src/test/regress/expected/privileges.out      |  24 ++--
 src/test/regress/expected/rangetypes.out      |  40 +++---
 src/test/regress/expected/regproc.out         | 114 +++++++++---------
 src/test/regress/expected/rowtypes.out        |  16 +--
 src/test/regress/expected/strings.out         |  24 ++--
 src/test/regress/expected/tid.out             |  16 +--
 src/test/regress/expected/time.out            |  16 +--
 src/test/regress/expected/timestamp.out       |  16 +--
 src/test/regress/expected/timestamptz.out     |  16 +--
 src/test/regress/expected/timetz.out          |  16 +--
 src/test/regress/expected/tstypes.out         |  24 ++--
 src/test/regress/expected/uuid.out            |   8 +-
 src/test/regress/expected/varchar.out         |   8 +-
 src/test/regress/expected/varchar_1.out       |   8 +-
 src/test/regress/expected/varchar_2.out       |   8 +-
 src/test/regress/expected/xid.out             |  32 ++---
 src/test/regress/expected/xml.out             |  10 +-
 src/test/regress/expected/xml_1.out           |   4 +-
 src/test/regress/expected/xml_2.out           |   8 +-
 src/test/regress/sql/arrays.sql               |   2 +-
 src/test/regress/sql/bit.sql                  |  10 +-
 src/test/regress/sql/boolean.sql              |   2 +-
 src/test/regress/sql/box.sql                  |   4 +-
 src/test/regress/sql/char.sql                 |   2 +-
 src/test/regress/sql/date.sql                 |   4 +-
 src/test/regress/sql/domain.sql               |  10 +-
 src/test/regress/sql/enum.sql                 |   4 +-
 src/test/regress/sql/float4.sql               |   2 +-
 src/test/regress/sql/float8.sql               |   2 +-
 src/test/regress/sql/geometry.sql             |   4 +-
 src/test/regress/sql/inet.sql                 |   6 +-
 src/test/regress/sql/int2.sql                 |   6 +-
 src/test/regress/sql/int4.sql                 |   2 +-
 src/test/regress/sql/int8.sql                 |   2 +-
 src/test/regress/sql/interval.sql             |   4 +-
 src/test/regress/sql/json.sql                 |   2 +-
 src/test/regress/sql/json_encoding.sql        |   2 +-
 src/test/regress/sql/jsonb.sql                |   4 +-
 src/test/regress/sql/jsonpath.sql             |   2 +-
 src/test/regress/sql/line.sql                 |  10 +-
 src/test/regress/sql/lseg.sql                 |   2 +-
 src/test/regress/sql/macaddr.sql              |   4 +-
 src/test/regress/sql/macaddr8.sql             |   4 +-
 src/test/regress/sql/money.sql                |   4 +-
 src/test/regress/sql/multirangetypes.sql      |   4 +-
 src/test/regress/sql/numeric.sql              |   6 +-
 src/test/regress/sql/oid.sql                  |   8 +-
 src/test/regress/sql/path.sql                 |   4 +-
 src/test/regress/sql/pg_lsn.sql               |   2 +-
 src/test/regress/sql/point.sql                |   2 +-
 src/test/regress/sql/polygon.sql              |   4 +-
 src/test/regress/sql/privileges.sql           |   6 +-
 src/test/regress/sql/rangetypes.sql           |  10 +-
 src/test/regress/sql/regproc.sql              |  34 +++---
 src/test/regress/sql/rowtypes.sql             |   4 +-
 src/test/regress/sql/strings.sql              |   6 +-
 src/test/regress/sql/tid.sql                  |   4 +-
 src/test/regress/sql/time.sql                 |   4 +-
 src/test/regress/sql/timestamp.sql            |   4 +-
 src/test/regress/sql/timestamptz.sql          |   4 +-
 src/test/regress/sql/timetz.sql               |   4 +-
 src/test/regress/sql/tstypes.sql              |   6 +-
 src/test/regress/sql/uuid.sql                 |   2 +-
 src/test/regress/sql/varchar.sql              |   2 +-
 src/test/regress/sql/xid.sql                  |   8 +-
 src/test/regress/sql/xml.sql                  |   4 +-
 117 files changed, 708 insertions(+), 669 deletions(-)

diff --git a/contrib/cube/sql/cube.sql b/contrib/cube/sql/cube.sql
index 384883d16e..2bb96e3490 100644
--- a/contrib/cube/sql/cube.sql
+++ b/contrib/cube/sql/cube.sql
@@ -83,7 +83,7 @@ SELECT '-1e-700'::cube AS cube; -- out of range
 SELECT pg_input_is_valid('(1,2)', 'cube');
 SELECT pg_input_is_valid('[(1),]', 'cube');
 SELECT pg_input_is_valid('-1e-700', 'cube');
-SELECT pg_input_error_message('-1e-700', 'cube');
+SELECT pg_input_error_info('-1e-700', 'cube');
 
 --
 -- Testing building cubes from float8 values
diff --git a/contrib/hstore/sql/hstore.sql b/contrib/hstore/sql/hstore.sql
index 15f4f71416..3cd009c62a 100644
--- a/contrib/hstore/sql/hstore.sql
+++ b/contrib/hstore/sql/hstore.sql
@@ -60,8 +60,8 @@ select 'aa=>"'::hstore;
 -- also try it with non-error-throwing API
 select pg_input_is_valid('a=>b', 'hstore');
 select pg_input_is_valid('a=b', 'hstore');
-select pg_input_error_message('a=b', 'hstore');
-select pg_input_error_message(' =>b', 'hstore');
+select pg_input_error_info('a=b', 'hstore');
+select pg_input_error_info(' =>b', 'hstore');
 
 
 -- -> operator
diff --git a/contrib/intarray/sql/_int.sql b/contrib/intarray/sql/_int.sql
index 4c9ba4c1fb..6dde5c5e33 100644
--- a/contrib/intarray/sql/_int.sql
+++ b/contrib/intarray/sql/_int.sql
@@ -79,7 +79,7 @@ SELECT '1&(2&(4&(5|!6)))'::query_int;
 
 SELECT str as "query_int",
        pg_input_is_valid(str,'query_int') as ok,
-       pg_input_error_message(str,'query_int') as errmsg
+       pg_input_error_info(str,'query_int') as errmsg
 FROM (VALUES ('1&(2&(4&(5|6)))'),
              ('1#(2&(4&(5&6)))'),
              ('foo'))
diff --git a/contrib/isn/sql/isn.sql b/contrib/isn/sql/isn.sql
index 6426cb42a0..9fcb1f5bfe 100644
--- a/contrib/isn/sql/isn.sql
+++ b/contrib/isn/sql/isn.sql
@@ -110,7 +110,7 @@ SELECT '12345679'::ISSN = '9771234567003'::EAN13 AS "ok",
 -- test non-error-throwing input API
 SELECT str as isn, typ as "type",
        pg_input_is_valid(str,typ) as ok,
-       pg_input_error_message(str,typ) as errmsg
+       pg_input_error_info(str,typ) as errmsg
 FROM (VALUES ('9780123456786', 'UPC'),
              ('postgresql...','EAN13'),
              ('9771234567003','ISSN'))
diff --git a/contrib/ltree/sql/ltree.sql b/contrib/ltree/sql/ltree.sql
index 4a6e6266c3..ab30792354 100644
--- a/contrib/ltree/sql/ltree.sql
+++ b/contrib/ltree/sql/ltree.sql
@@ -393,7 +393,7 @@ SELECT count(*) FROM _ltreetest WHERE t ? '{23.*.1,23.*.2}' ;
 
 SELECT str as "value", typ as "type",
        pg_input_is_valid(str,typ) as ok,
-       pg_input_error_message(str,typ) as errmsg
+       pg_input_error_info(str,typ) as errmsg
 FROM (VALUES ('.2.3', 'ltree'),
              ('1.2.', 'ltree'),
              ('1.2.3','ltree'),
diff --git a/contrib/seg/sql/seg.sql b/contrib/seg/sql/seg.sql
index b9a5d05d09..b2a96e84ba 100644
--- a/contrib/seg/sql/seg.sql
+++ b/contrib/seg/sql/seg.sql
@@ -244,7 +244,7 @@ FROM test_seg WHERE s @> '11.2..11.3' OR s IS NULL ORDER BY s;
 
 SELECT str as seg,
        pg_input_is_valid(str,'seg') as ok,
-       pg_input_error_message(str,'seg') as errmsg
+       pg_input_error_info(str,'seg') as errmsg
 FROM unnest(ARRAY['-1 .. 1'::text,
                   '100(+-)1',
                   '',
diff --git a/doc/src/sgml/func.sgml b/doc/src/sgml/func.sgml
index 0cbdf63632..97b3f1c1a6 100644
--- a/doc/src/sgml/func.sgml
+++ b/doc/src/sgml/func.sgml
@@ -24775,19 +24775,23 @@ SELECT collation for ('foo' COLLATE "de_DE");
       <row>
        <entry role="func_table_entry"><para role="func_signature">
         <indexterm>
-         <primary>pg_input_error_message</primary>
+         <primary>pg_input_error_info</primary>
         </indexterm>
-        <function>pg_input_error_message</function> (
+        <function>pg_input_error_info</function> (
           <parameter>string</parameter> <type>text</type>,
           <parameter>type</parameter> <type>text</type>
         )
-        <returnvalue>text</returnvalue>
+        <returnvalue>record</returnvalue>
+        ( <parameter>message</parameter> <type>text</type>,
+        <parameter>detail</parameter> <type>text</type>,
+        <parameter>hint</parameter> <type>text</type>,
+        <parameter>sql_error_code</parameter> <type>text</type> )
        </para>
        <para>
         Tests whether the given <parameter>string</parameter> is valid
-        input for the specified data type; if not, return the error
-        message that would have been thrown.  If the input is valid, the
-        result is NULL.  The inputs are the same as
+        input for the specified data type; if not, return the details of
+        the error would have been thrown.  If the input is valid, the
+        results are NULL.  The inputs are the same as
         for <function>pg_input_is_valid</function>.
        </para>
        <para>
@@ -24798,12 +24802,17 @@ SELECT collation for ('foo' COLLATE "de_DE");
         directly.
         </para>
         <para>
-         <literal>pg_input_error_message('42000000000', 'integer')</literal>
-         <returnvalue>value "42000000000" is out of range for type integer</returnvalue>
-        </para>
-        <para>
-         <literal>pg_input_error_message('1234.567', 'numeric(7,4)')</literal>
-         <returnvalue>numeric field overflow</returnvalue>
+<programlisting>
+SELECT * FROM pg_input_error_info('42000000000', 'integer');
+                       message                        | detail | hint | sql_error_code
+------------------------------------------------------+--------+------+----------------
+ value "42000000000" is out of range for type integer |        |      | 22003
+
+SELECT * FROM pg_input_error_info('1234.567', 'numeric(7,4)');
+        message         |                                      detail                                       | hint | sql_error_code
+------------------------+-----------------------------------------------------------------------------------+------+----------------
+ numeric field overflow | A field with precision 7, scale 4 must round to an absolute value less than 10^3. |      | 22003
+</programlisting>
        </para></entry>
       </row>
      </tbody>
diff --git a/src/backend/utils/adt/misc.c b/src/backend/utils/adt/misc.c
index f95256efd3..182d16cdcd 100644
--- a/src/backend/utils/adt/misc.c
+++ b/src/backend/utils/adt/misc.c
@@ -660,32 +660,58 @@ pg_input_is_valid(PG_FUNCTION_ARGS)
 }
 
 /*
- * pg_input_error_message - test whether string is valid input for datatype.
+ * pg_input_error_info - test whether string is valid input for datatype.
  *
- * Returns NULL if OK, else the primary message string from the error.
+ * Returns NULL if OK, else the primary message, detail message, hint message,
+ * and sql error code from the error.
  *
  * This will only work usefully if the datatype's input function has been
  * updated to return "soft" errors via errsave/ereturn.
  */
 Datum
-pg_input_error_message(PG_FUNCTION_ARGS)
+pg_input_error_info(PG_FUNCTION_ARGS)
 {
 	text	   *txt = PG_GETARG_TEXT_PP(0);
 	text	   *typname = PG_GETARG_TEXT_PP(1);
 	ErrorSaveContext escontext = {T_ErrorSaveContext};
+	TupleDesc   tupdesc;
+	Datum       values[4];
+	bool        isnull[4];
+
+	if (get_call_result_type(fcinfo, NULL, &tupdesc) != TYPEFUNC_COMPOSITE)
+		elog(ERROR, "return type must be a row type");
 
 	/* Enable details_wanted */
 	escontext.details_wanted = true;
 
 	if (pg_input_is_valid_common(fcinfo, txt, typname,
 								 &escontext))
-		PG_RETURN_NULL();
+		memset(isnull, true, sizeof(isnull));
+	else
+	{
+		Assert(escontext.error_occurred);
+		Assert(escontext.error_data != NULL);
+		Assert(escontext.error_data->message != NULL);
+
+		memset(isnull, false, sizeof(isnull));
+
+		values[0] = CStringGetTextDatum(escontext.error_data->message);
 
-	Assert(escontext.error_occurred);
-	Assert(escontext.error_data != NULL);
-	Assert(escontext.error_data->message != NULL);
+		if (escontext.error_data->detail != NULL)
+			values[1] = CStringGetTextDatum(escontext.error_data->detail);
+		else
+			isnull[1] = true;
+
+		if (escontext.error_data->hint != NULL)
+			values[2] = CStringGetTextDatum(escontext.error_data->hint);
+		else
+			isnull[2] = true;
+
+		values[3] = CStringGetTextDatum(
+			unpack_sql_state(escontext.error_data->sqlerrcode));
+	}
 
-	PG_RETURN_TEXT_P(cstring_to_text(escontext.error_data->message));
+	return HeapTupleGetDatum(heap_form_tuple(tupdesc, values, isnull));
 }
 
 /* Common subroutine for the above */
diff --git a/src/test/regress/sql/arrays.sql b/src/test/regress/sql/arrays.sql
index 38e8dd440b..954c1225b4 100644
--- a/src/test/regress/sql/arrays.sql
+++ b/src/test/regress/sql/arrays.sql
@@ -117,7 +117,7 @@ SELECT a,b,c FROM arrtest;
 SELECT pg_input_is_valid('{1,2,3}', 'integer[]');
 SELECT pg_input_is_valid('{1,2', 'integer[]');
 SELECT pg_input_is_valid('{1,zed}', 'integer[]');
-SELECT pg_input_error_message('{1,zed}', 'integer[]');
+SELECT pg_input_error_info('{1,zed}', 'integer[]');
 
 -- test mixed slice/scalar subscripting
 select '{{1,2,3},{4,5,6},{7,8,9}}'::int[];
diff --git a/src/test/regress/sql/bit.sql b/src/test/regress/sql/bit.sql
index 8814249c2a..5765ee8672 100644
--- a/src/test/regress/sql/bit.sql
+++ b/src/test/regress/sql/bit.sql
@@ -232,13 +232,13 @@ TABLE bit_defaults;
 
 -- test non-error-throwing API for some core types
 SELECT pg_input_is_valid('01010001', 'bit(10)');
-SELECT pg_input_error_message('01010001', 'bit(10)');
+SELECT pg_input_error_info('01010001', 'bit(10)');
 SELECT pg_input_is_valid('01010Z01', 'bit(8)');
-SELECT pg_input_error_message('01010Z01', 'bit(8)');
+SELECT pg_input_error_info('01010Z01', 'bit(8)');
 SELECT pg_input_is_valid('x01010Z01', 'bit(32)');
-SELECT pg_input_error_message('x01010Z01', 'bit(32)');
+SELECT pg_input_error_info('x01010Z01', 'bit(32)');
 
 SELECT pg_input_is_valid('01010Z01', 'varbit');
-SELECT pg_input_error_message('01010Z01', 'varbit');
+SELECT pg_input_error_info('01010Z01', 'varbit');
 SELECT pg_input_is_valid('x01010Z01', 'varbit');
-SELECT pg_input_error_message('x01010Z01', 'varbit');
+SELECT pg_input_error_info('x01010Z01', 'varbit');
diff --git a/src/test/regress/sql/boolean.sql b/src/test/regress/sql/boolean.sql
index dfaa55dd0f..9126831dba 100644
--- a/src/test/regress/sql/boolean.sql
+++ b/src/test/regress/sql/boolean.sql
@@ -65,7 +65,7 @@ SELECT bool '' AS error;
 -- Also try it with non-error-throwing API
 SELECT pg_input_is_valid('true', 'bool');
 SELECT pg_input_is_valid('asdf', 'bool');
-SELECT pg_input_error_message('junk', 'bool');
+SELECT pg_input_error_info('junk', 'bool');
 
 -- and, or, not in qualifications
 
diff --git a/src/test/regress/sql/box.sql b/src/test/regress/sql/box.sql
index 02e100391b..cbf967f3ae 100644
--- a/src/test/regress/sql/box.sql
+++ b/src/test/regress/sql/box.sql
@@ -284,6 +284,6 @@ RESET enable_bitmapscan;
 
 -- test non-error-throwing API for some core types
 SELECT pg_input_is_valid('200', 'box');
-SELECT pg_input_error_message('200', 'box');
+SELECT pg_input_error_info('200', 'box');
 SELECT pg_input_is_valid('((200,300),(500, xyz))', 'box');
-SELECT pg_input_error_message('((200,300),(500, xyz))', 'box');
+SELECT pg_input_error_info('((200,300),(500, xyz))', 'box');
diff --git a/src/test/regress/sql/char.sql b/src/test/regress/sql/char.sql
index 8aa43b0fb8..f8e3304053 100644
--- a/src/test/regress/sql/char.sql
+++ b/src/test/regress/sql/char.sql
@@ -75,7 +75,7 @@ SELECT * FROM CHAR_TBL;
 -- Also try it with non-error-throwing API
 SELECT pg_input_is_valid('abcd  ', 'char(4)');
 SELECT pg_input_is_valid('abcde', 'char(4)');
-SELECT pg_input_error_message('abcde', 'char(4)');
+SELECT pg_input_error_info('abcde', 'char(4)');
 
 --
 -- Also test "char", which is an ad-hoc one-byte type.  It can only
diff --git a/src/test/regress/sql/date.sql b/src/test/regress/sql/date.sql
index 89982dd2f8..8ced2c9bc5 100644
--- a/src/test/regress/sql/date.sql
+++ b/src/test/regress/sql/date.sql
@@ -197,8 +197,8 @@ SELECT date '5874898-01-01';  -- out of range
 SELECT pg_input_is_valid('now', 'date');
 SELECT pg_input_is_valid('garbage', 'date');
 SELECT pg_input_is_valid('6874898-01-01', 'date');
-SELECT pg_input_error_message('garbage', 'date');
-SELECT pg_input_error_message('6874898-01-01', 'date');
+SELECT pg_input_error_info('garbage', 'date');
+SELECT pg_input_error_info('6874898-01-01', 'date');
 
 RESET datestyle;
 
diff --git a/src/test/regress/sql/domain.sql b/src/test/regress/sql/domain.sql
index 1558bd9a33..8ee0170369 100644
--- a/src/test/regress/sql/domain.sql
+++ b/src/test/regress/sql/domain.sql
@@ -77,12 +77,12 @@ create domain weirdfloat float8 check((1 / value) < 10);
 select pg_input_is_valid('1', 'positiveint');
 select pg_input_is_valid('junk', 'positiveint');
 select pg_input_is_valid('-1', 'positiveint');
-select pg_input_error_message('junk', 'positiveint');
-select pg_input_error_message('-1', 'positiveint');
-select pg_input_error_message('junk', 'weirdfloat');
-select pg_input_error_message('0.01', 'weirdfloat');
+select pg_input_error_info('junk', 'positiveint');
+select pg_input_error_info('-1', 'positiveint');
+select pg_input_error_info('junk', 'weirdfloat');
+select pg_input_error_info('0.01', 'weirdfloat');
 -- We currently can't trap errors raised in the CHECK expression itself
-select pg_input_error_message('0', 'weirdfloat');
+select pg_input_error_info('0', 'weirdfloat');
 
 drop domain positiveint;
 drop domain weirdfloat;
diff --git a/src/test/regress/sql/enum.sql b/src/test/regress/sql/enum.sql
index c87656589b..417fa6eddd 100644
--- a/src/test/regress/sql/enum.sql
+++ b/src/test/regress/sql/enum.sql
@@ -18,8 +18,8 @@ SELECT 'mauve'::rainbow;
 -- Also try it with non-error-throwing API
 SELECT pg_input_is_valid('red', 'rainbow');
 SELECT pg_input_is_valid('mauve', 'rainbow');
-SELECT pg_input_error_message('mauve', 'rainbow');
-SELECT pg_input_error_message(repeat('too_long', 32), 'rainbow');
+SELECT pg_input_error_info('mauve', 'rainbow');
+SELECT pg_input_error_info(repeat('too_long', 32), 'rainbow');
 
 --
 -- adding new values
diff --git a/src/test/regress/sql/float4.sql b/src/test/regress/sql/float4.sql
index 061477726b..4f344997e9 100644
--- a/src/test/regress/sql/float4.sql
+++ b/src/test/regress/sql/float4.sql
@@ -40,7 +40,7 @@ INSERT INTO FLOAT4_TBL(f1) VALUES ('123            5');
 SELECT pg_input_is_valid('34.5', 'float4');
 SELECT pg_input_is_valid('xyz', 'float4');
 SELECT pg_input_is_valid('1e400', 'float4');
-SELECT pg_input_error_message('1e400', 'float4');
+SELECT pg_input_error_info('1e400', 'float4');
 
 -- special inputs
 SELECT 'NaN'::float4;
diff --git a/src/test/regress/sql/float8.sql b/src/test/regress/sql/float8.sql
index c276a5324c..d5fd409580 100644
--- a/src/test/regress/sql/float8.sql
+++ b/src/test/regress/sql/float8.sql
@@ -38,7 +38,7 @@ INSERT INTO FLOAT8_TBL(f1) VALUES ('123           5');
 SELECT pg_input_is_valid('34.5', 'float8');
 SELECT pg_input_is_valid('xyz', 'float8');
 SELECT pg_input_is_valid('1e4000', 'float8');
-SELECT pg_input_error_message('1e4000', 'float8');
+SELECT pg_input_error_info('1e4000', 'float8');
 
 -- special inputs
 SELECT 'NaN'::float8;
diff --git a/src/test/regress/sql/geometry.sql b/src/test/regress/sql/geometry.sql
index 309234b76c..70576ab7ff 100644
--- a/src/test/regress/sql/geometry.sql
+++ b/src/test/regress/sql/geometry.sql
@@ -526,6 +526,6 @@ SELECT * FROM polygon_tbl WHERE f1 @> '((1,1),(2,2),(2,1))'::polygon
 
 -- test non-error-throwing API for some core types
 SELECT pg_input_is_valid('(1', 'circle');
-SELECT pg_input_error_message('1,', 'circle');
+SELECT pg_input_error_info('1,', 'circle');
 SELECT pg_input_is_valid('(1,2),-1', 'circle');
-SELECT pg_input_error_message('(1,2),-1', 'circle');
+SELECT pg_input_error_info('(1,2),-1', 'circle');
diff --git a/src/test/regress/sql/inet.sql b/src/test/regress/sql/inet.sql
index abfcd4242f..ae3f19d285 100644
--- a/src/test/regress/sql/inet.sql
+++ b/src/test/regress/sql/inet.sql
@@ -255,9 +255,9 @@ SELECT a FROM (VALUES
 
 -- test non-error-throwing API for some core types
 SELECT pg_input_is_valid('1234', 'cidr');
-SELECT pg_input_error_message('1234', 'cidr');
+SELECT pg_input_error_info('1234', 'cidr');
 SELECT pg_input_is_valid('192.168.198.200/24', 'cidr');
-SELECT pg_input_error_message('192.168.198.200/24', 'cidr');
+SELECT pg_input_error_info('192.168.198.200/24', 'cidr');
 
 SELECT pg_input_is_valid('1234', 'inet');
-SELECT pg_input_error_message('1234', 'inet');
+SELECT pg_input_error_info('1234', 'inet');
diff --git a/src/test/regress/sql/int2.sql b/src/test/regress/sql/int2.sql
index ce8ac97963..7da875c402 100644
--- a/src/test/regress/sql/int2.sql
+++ b/src/test/regress/sql/int2.sql
@@ -21,12 +21,12 @@ SELECT * FROM INT2_TBL;
 SELECT pg_input_is_valid('34', 'int2');
 SELECT pg_input_is_valid('asdf', 'int2');
 SELECT pg_input_is_valid('50000', 'int2');
-SELECT pg_input_error_message('50000', 'int2');
+SELECT pg_input_error_info('50000', 'int2');
 
 -- While we're here, check int2vector as well
 SELECT pg_input_is_valid(' 1 3  5 ', 'int2vector');
-SELECT pg_input_error_message('1 asdf', 'int2vector');
-SELECT pg_input_error_message('50000', 'int2vector');
+SELECT pg_input_error_info('1 asdf', 'int2vector');
+SELECT pg_input_error_info('50000', 'int2vector');
 
 SELECT * FROM INT2_TBL AS f(a, b);
 
diff --git a/src/test/regress/sql/int4.sql b/src/test/regress/sql/int4.sql
index 146963edfb..659d1ab939 100644
--- a/src/test/regress/sql/int4.sql
+++ b/src/test/regress/sql/int4.sql
@@ -21,7 +21,7 @@ SELECT * FROM INT4_TBL;
 SELECT pg_input_is_valid('34', 'int4');
 SELECT pg_input_is_valid('asdf', 'int4');
 SELECT pg_input_is_valid('1000000000000', 'int4');
-SELECT pg_input_error_message('1000000000000', 'int4');
+SELECT pg_input_error_info('1000000000000', 'int4');
 
 SELECT i.* FROM INT4_TBL i WHERE i.f1 <> int2 '0';
 
diff --git a/src/test/regress/sql/int8.sql b/src/test/regress/sql/int8.sql
index c85717c072..14bc99bd5e 100644
--- a/src/test/regress/sql/int8.sql
+++ b/src/test/regress/sql/int8.sql
@@ -20,7 +20,7 @@ SELECT * FROM INT8_TBL;
 SELECT pg_input_is_valid('34', 'int8');
 SELECT pg_input_is_valid('asdf', 'int8');
 SELECT pg_input_is_valid('10000000000000000000', 'int8');
-SELECT pg_input_error_message('10000000000000000000', 'int8');
+SELECT pg_input_error_info('10000000000000000000', 'int8');
 
 -- int8/int8 cmp
 SELECT * FROM INT8_TBL WHERE q2 = 4567890123456789;
diff --git a/src/test/regress/sql/interval.sql b/src/test/regress/sql/interval.sql
index af8e1ca0f4..171bbbf653 100644
--- a/src/test/regress/sql/interval.sql
+++ b/src/test/regress/sql/interval.sql
@@ -36,8 +36,8 @@ INSERT INTO INTERVAL_TBL (f1) VALUES ('@ 30 eons ago');
 SELECT pg_input_is_valid('1.5 weeks', 'interval');
 SELECT pg_input_is_valid('garbage', 'interval');
 SELECT pg_input_is_valid('@ 30 eons ago', 'interval');
-SELECT pg_input_error_message('garbage', 'interval');
-SELECT pg_input_error_message('@ 30 eons ago', 'interval');
+SELECT pg_input_error_info('garbage', 'interval');
+SELECT pg_input_error_info('@ 30 eons ago', 'interval');
 
 -- test interval operators
 
diff --git a/src/test/regress/sql/json.sql b/src/test/regress/sql/json.sql
index 21534ed959..68e4c9af8f 100644
--- a/src/test/regress/sql/json.sql
+++ b/src/test/regress/sql/json.sql
@@ -84,7 +84,7 @@ SELECT '{
 -- test non-error-throwing input
 select pg_input_is_valid('{"a":true}', 'json');
 select pg_input_is_valid('{"a":true', 'json');
-select pg_input_error_message('{"a":true', 'json');
+select pg_input_error_info('{"a":true', 'json');
 
 --constructors
 -- array_to_json
diff --git a/src/test/regress/sql/json_encoding.sql b/src/test/regress/sql/json_encoding.sql
index f87b3bd4f3..e7d11fd25b 100644
--- a/src/test/regress/sql/json_encoding.sql
+++ b/src/test/regress/sql/json_encoding.sql
@@ -79,4 +79,4 @@ SELECT jsonb '{ "a":  "null \\u0000 escape" }' ->> 'a' as not_an_escape;
 
 -- soft error for input-time failure
 
-select pg_input_error_message('{ "a":  "\ud83d\ude04\ud83d\udc36" }', 'jsonb');
+select pg_input_error_info('{ "a":  "\ud83d\ude04\ud83d\udc36" }', 'jsonb');
diff --git a/src/test/regress/sql/jsonb.sql b/src/test/regress/sql/jsonb.sql
index 9f67f4c71d..651e9408ec 100644
--- a/src/test/regress/sql/jsonb.sql
+++ b/src/test/regress/sql/jsonb.sql
@@ -89,8 +89,8 @@ SELECT '{
 -- test non-error-throwing input
 select pg_input_is_valid('{"a":true}', 'jsonb');
 select pg_input_is_valid('{"a":true', 'jsonb');
-select pg_input_error_message('{"a":true', 'jsonb');
-select pg_input_error_message('{"a":1e1000000}', 'jsonb');
+select pg_input_error_info('{"a":true', 'jsonb');
+select pg_input_error_info('{"a":1e1000000}', 'jsonb');
 
 -- make sure jsonb is passed through json generators without being escaped
 SELECT array_to_json(ARRAY [jsonb '{"a":1}', jsonb '{"b":[2,3]}']);
diff --git a/src/test/regress/sql/jsonpath.sql b/src/test/regress/sql/jsonpath.sql
index 99d21d2af7..2fba9c1057 100644
--- a/src/test/regress/sql/jsonpath.sql
+++ b/src/test/regress/sql/jsonpath.sql
@@ -192,7 +192,7 @@ select '1?(2>3)'::jsonpath;
 
 SELECT str as jsonpath,
        pg_input_is_valid(str,'jsonpath') as ok,
-       pg_input_error_message(str,'jsonpath') as errmsg
+       pg_input_error_info(str,'jsonpath') as errmsg
 FROM unnest(ARRAY['$ ? (@ like_regex "pattern" flag "smixq")'::text,
                   '$ ? (@ like_regex "pattern" flag "a")',
                   '@ + 1',
diff --git a/src/test/regress/sql/line.sql b/src/test/regress/sql/line.sql
index f706a41184..42b37138e9 100644
--- a/src/test/regress/sql/line.sql
+++ b/src/test/regress/sql/line.sql
@@ -43,12 +43,12 @@ select '{nan, 1, nan}'::line = '{nan, 1, nan}'::line as true,
 
 -- test non-error-throwing API for some core types
 SELECT pg_input_is_valid('{1, 1}', 'line');
-SELECT pg_input_error_message('{1, 1}', 'line');
+SELECT pg_input_error_info('{1, 1}', 'line');
 SELECT pg_input_is_valid('{0, 0, 0}', 'line');
-SELECT pg_input_error_message('{0, 0, 0}', 'line');
+SELECT pg_input_error_info('{0, 0, 0}', 'line');
 SELECT pg_input_is_valid('{1, 1, a}', 'line');
-SELECT pg_input_error_message('{1, 1, a}', 'line');
+SELECT pg_input_error_info('{1, 1, a}', 'line');
 SELECT pg_input_is_valid('{1, 1, 1e400}', 'line');
-SELECT pg_input_error_message('{1, 1, 1e400}', 'line');
+SELECT pg_input_error_info('{1, 1, 1e400}', 'line');
 SELECT pg_input_is_valid('(1, 1), (1, 1e400)', 'line');
-SELECT pg_input_error_message('(1, 1), (1, 1e400)', 'line');
+SELECT pg_input_error_info('(1, 1), (1, 1e400)', 'line');
diff --git a/src/test/regress/sql/lseg.sql b/src/test/regress/sql/lseg.sql
index 0fece162e0..095a798017 100644
--- a/src/test/regress/sql/lseg.sql
+++ b/src/test/regress/sql/lseg.sql
@@ -25,4 +25,4 @@ select * from LSEG_TBL;
 
 -- test non-error-throwing API for some core types
 SELECT pg_input_is_valid('[(1,2),(3)]', 'lseg');
-SELECT pg_input_error_message('[(1,2),(3)]', 'lseg');
+SELECT pg_input_error_info('[(1,2),(3)]', 'lseg');
diff --git a/src/test/regress/sql/macaddr.sql b/src/test/regress/sql/macaddr.sql
index 211397c8f3..56a24cd88f 100644
--- a/src/test/regress/sql/macaddr.sql
+++ b/src/test/regress/sql/macaddr.sql
@@ -44,6 +44,6 @@ DROP TABLE macaddr_data;
 
 -- test non-error-throwing API for some core types
 SELECT pg_input_is_valid('08:00:2b:01:02:ZZ', 'macaddr');
-SELECT pg_input_error_message('08:00:2b:01:02:ZZ', 'macaddr');
+SELECT pg_input_error_info('08:00:2b:01:02:ZZ', 'macaddr');
 SELECT pg_input_is_valid('08:00:2b:01:02:', 'macaddr');
-SELECT pg_input_error_message('08:00:2b:01:02:', 'macaddr');
+SELECT pg_input_error_info('08:00:2b:01:02:', 'macaddr');
diff --git a/src/test/regress/sql/macaddr8.sql b/src/test/regress/sql/macaddr8.sql
index b29f785b41..a796034cc5 100644
--- a/src/test/regress/sql/macaddr8.sql
+++ b/src/test/regress/sql/macaddr8.sql
@@ -90,6 +90,6 @@ DROP TABLE macaddr8_data;
 
 -- test non-error-throwing API for some core types
 SELECT pg_input_is_valid('08:00:2b:01:02:03:04:ZZ', 'macaddr8');
-SELECT pg_input_error_message('08:00:2b:01:02:03:04:ZZ', 'macaddr8');
+SELECT pg_input_error_info('08:00:2b:01:02:03:04:ZZ', 'macaddr8');
 SELECT pg_input_is_valid('08:00:2b:01:02:03:04:', 'macaddr8');
-SELECT pg_input_error_message('08:00:2b:01:02:03:04:', 'macaddr8');
+SELECT pg_input_error_info('08:00:2b:01:02:03:04:', 'macaddr8');
diff --git a/src/test/regress/sql/money.sql b/src/test/regress/sql/money.sql
index cd9a089e01..073aa0a38b 100644
--- a/src/test/regress/sql/money.sql
+++ b/src/test/regress/sql/money.sql
@@ -90,9 +90,9 @@ SELECT '($123,456.78)'::money;
 
 -- test non-error-throwing API
 SELECT pg_input_is_valid('\x0001', 'money');
-SELECT pg_input_error_message('\x0001', 'money');
+SELECT pg_input_error_info('\x0001', 'money');
 SELECT pg_input_is_valid('192233720368547758.07', 'money');
-SELECT pg_input_error_message('192233720368547758.07', 'money');
+SELECT pg_input_error_info('192233720368547758.07', 'money');
 
 -- documented minimums and maximums
 SELECT '-92233720368547758.08'::money;
